execute if block 4 81 -2 stone_button[powered=true] run function main:troll1
execute unless blocks 0 82 4 0 82 4 -1 77 4 all if block 2 80 5 grass_block if block 0 80 7 grass_block if block 2 81 5 dark_oak_fence_gate[open=true] if entity @p[x=2,y=81,z=5,dx=0,dy=0,dz=0,tag=!travelled] run function main:troll2
execute if block -3 77 6 gold_block if block 0 80 7 grass_block if block 2 80 5 grass_block if block 0 81 7 oak_fence_gate[open=true] if entity @p[x=0,y=81,z=7,dx=0,dy=0,dz=0,tag=!travelled] run function main:troll3

execute as @e[type=arrow] at @s if entity @e[type=armor_stand,tag=follow,limit=1,distance=..2.5] run function main:officer_shot
execute if score Global officer1 matches 1.. run function main:officer_shot

execute as @a[scores={speed=1..},tag=!travelled] at @s if block ~ ~-0.1 ~ white_stained_glass run function main:officer_speed
execute if score Global officer2 matches 1.. run function main:officer_speed

execute if block -3 77 6 gold_block if blocks 0 82 4 0 82 4 -2 77 5 all if block -10 94 12 oak_button[powered=true] run function main:oak_gate
execute if block -3 77 6 air run particle minecraft:happy_villager 2 82 5 0.2 0 0.2 1 1

execute if block 3 80 10 grass_block if entity @p[x=1,y=81,z=10,dx=2,dy=1,dz=0,tag=!travelled] run function main:walk
execute if score Global walk matches 1.. run function main:walk

execute if score Global break_glass matches 0 if entity @p[x=0,y=81,z=15,dx=0,dy=0,dz=0,tag=!travelled] run function main:break_glass
execute if score Global break_glass matches 1.. run function main:break_glass

execute if block -2 80 15 white_stained_glass if entity @p[x=-3,y=81,z=15,dx=0,dy=0,dz=0,tag=!travelled] run function main:finish_glass

execute if block -3 81 9 air if entity @p[x=-3,y=81,z=7,dx=2,dy=1,dz=0,tag=!travelled] run function main:reset_lava

execute if blocks 0 82 4 0 82 4 -1 77 4 all run particle minecraft:happy_villager 0 82 7 0.2 0 0.2 1 1

execute if blocks 0 82 4 0 82 4 -1 77 4 all if entity @p[x=1,y=81,z=9,dx=2,dy=1,dz=0,tag=!travelled] run function main:parkour

execute if score Global door matches 0 if entity @p[x=-3,y=81,z=17,dx=6,dy=0,dz=1,tag=!travelled] run function main:time_machine_door
execute if score Global door matches 1..29 run function main:time_machine_door
execute if score Global door matches 30 if entity @p[x=-1,y=81,z=21,dx=2,dy=1,dz=1,tag=!travelled] run function main:inside_time_machine
execute if score Global door matches 31..65 run function main:time_machine_door

execute unless score Global door matches 0 if block -1 82 20 oak_button[powered=true] run function main:time_machine_button1
execute unless score Global door matches 0 if block -1 82 21 oak_button[powered=true] run function main:time_machine_button2
execute unless score Global door matches 0 if block -1 82 22 lever[powered=true] run function main:time_machine_lever

execute if score Global door matches 0 if score Global time_machine matches 0 if block -1 82 22 lever[powered=true] run function main:start_time_machine
execute if score Global time_machine matches 1.. run function main:start_time_machine

execute as @a[scores={rightclick=1..}] at @s if entity @e[type=villager,tag=coal,sort=nearest,distance=..1] run function main:coal
execute as @a[scores={rightclick=1..}] at @s if entity @e[type=villager,tag=stick,sort=nearest,distance=..1] run function main:stick

execute if block 18 85 3 redstone_block if block 17 85 0 oak_button[powered=true] run setblock 18 85 3 air
execute if block 18 85 3 air if score Global redstone1 matches 0 if block 17 85 0 oak_button[powered=false] run function main:redstone1
execute if score Global redstone1 matches 1.. run function main:redstone1

execute if block 12 84 34 redstone_block if block 13 84 32 lever[powered=true] run setblock 12 84 34 air
execute if block 12 84 34 air unless block 13 84 32 lever[powered=true] run setblock 12 84 34 redstone_block

execute if block 17 83 42 dark_oak_button[powered=true] run function main:reset
execute if score Global redstone2 matches 0 if block 17 83 38 birch_button[powered=true] run function main:redstone2
execute if score Global redstone2 matches 1.. run function main:redstone2

execute if block -2 82 22 quartz_pillar if entity @p[tag=travelled,tag=!travelled2] if entity @p[x=-1,y=81,z=20,dx=2,dy=1,dz=2,nbt={SelectedItem:{id:"minecraft:lever",tag:{display:{Name:'{"text":"Emergency Time Machine Lever","color":"yellow","italic":false}'}}}}] run setblock -2 82 22 minecraft:chiseled_quartz_block
execute if block -2 82 22 chiseled_quartz_block if entity @p[tag=travelled,tag=!travelled2] unless entity @p[x=-1,y=81,z=20,dx=2,dy=1,dz=2,nbt={SelectedItem:{id:"minecraft:lever",tag:{display:{Name:'{"text":"Emergency Time Machine Lever","color":"yellow","italic":false}'}}}}] run setblock -2 82 22 minecraft:quartz_pillar

execute if block -1 82 22 lever if score Global door matches 30 if entity @p[x=-1,y=81,z=21,dx=2,dy=1,dz=1,tag=travelled,tag=!travelled2] run function main:inside_time_machine
execute if score Global door matches 0 if score Global redstone2 matches -1 if score Global time_machine2 matches 0 if block -1 82 22 lever[powered=true] run function main:start_time_machine2
execute if score Global time_machine2 matches 1.. run function main:start_time_machine2

execute if entity @e[type=sheep,name=jeb_] run scoreboard players set Global sheepE 1
execute if score Global sheep matches 0 if entity @p[scores={mobkill=1..}] if score Global sheepE matches 0 run function main:sheep

execute if block -2 82 22 quartz_pillar if entity @p[tag=travelled,tag=travelled2] if entity @p[x=-1,y=81,z=20,dx=2,dy=1,dz=2,nbt={SelectedItem:{id:"minecraft:lever",tag:{display:{Name:'{"text":"Time Machine Starter","color":"yellow","italic":false}'}}}}] run setblock -2 82 22 minecraft:chiseled_quartz_block
execute if block -2 82 22 chiseled_quartz_block if entity @p[tag=travelled,tag=travelled2] unless entity @p[x=-1,y=81,z=20,dx=2,dy=1,dz=2,nbt={SelectedItem:{id:"minecraft:lever",tag:{display:{Name:'{"text":"Time Machine Starter","color":"yellow","italic":false}'}}}}] run setblock -2 82 22 minecraft:quartz_pillar

execute if block -1 82 22 lever if score Global door matches 30 if entity @p[x=-1,y=81,z=21,dx=2,dy=1,dz=1,tag=travelled,tag=travelled2,tag=!travelled3] run function main:inside_time_machine
execute if score Global door matches 0 if score Global sheep matches 1 if score Global time_machine3 matches 0 if block -1 82 22 lever[powered=true] run function main:start_time_machine3
execute if score Global time_machine3 matches 1.. run function main:start_time_machine3

execute if score Global end matches 1.. run function main:end

execute if entity @p[x=-3,y=81,z=2,dx=6,dy=1,dz=0,tag=end] run function main:end2

### ADVANCEMENTS

execute if entity @p[x=-3,y=81,z=2,dx=6,dy=1,dz=0] run advancement grant @a only main:root

execute if score Global advancement1 matches 0 if block -1 82 20 oak_button[powered=true] run scoreboard players set Global advancement1 1
execute if score Global advancement1 matches 1 if block -1 82 21 oak_button[powered=true] run scoreboard players set Global advancement1 2
execute if score Global advancement1 matches 2 if block -1 82 22 lever[powered=true] run scoreboard players set Global advancement1 3
execute if score Global advancement1 matches 3 if entity @e[type=item_frame,tag=clock,limit=1,nbt={ItemRotation:0b}] run scoreboard players set Global advancement1 4
execute if score Global advancement1 matches 4 if entity @e[type=item_frame,tag=clock,limit=1,nbt={ItemRotation:1b}] run scoreboard players set Global advancement1 5
execute if score Global advancement1 matches 5 if entity @e[type=item_frame,tag=clock,limit=1,nbt={ItemRotation:2b}] run scoreboard players set Global advancement1 6
execute if score Global advancement1 matches 6 if entity @e[type=item_frame,tag=clock,limit=1,nbt={ItemRotation:3b}] run scoreboard players set Global advancement1 7
execute if score Global advancement1 matches 7 if entity @e[type=item_frame,tag=clock,limit=1,nbt={ItemRotation:4b}] run scoreboard players set Global advancement1 8
execute if score Global advancement1 matches 8 if entity @e[type=item_frame,tag=clock,limit=1,nbt={ItemRotation:5b}] run scoreboard players set Global advancement1 9
execute if score Global advancement1 matches 9 if entity @e[type=item_frame,tag=clock,limit=1,nbt={ItemRotation:6b}] run scoreboard players set Global advancement1 10
execute if score Global advancement1 matches 10 if entity @e[type=item_frame,tag=clock,limit=1,nbt={ItemRotation:7b}] run scoreboard players set Global advancement1 11
execute if score Global advancement1 matches 11 run advancement grant @a only main:time

execute as @e[type=item] if entity @p[tag=throwing] run data merge entity @s {PickupDelay:0}
execute if entity @p[x=0,y=81,z=0,dx=0,dy=0,dz=0] run effect give @a saturation 1 127 true
execute if entity @p[x=0,y=81,z=0,dx=0,dy=0,dz=0] if block 0 80 0 gold_block run function main:final_reset
execute as @e[type=falling_block] run data merge entity @s {Time:1}
execute as @a[scores={rightclick=1..}] run scoreboard players set @s rightclick 0
execute as @a[scores={speed=1..}] run scoreboard players set @s speed 0
execute as @a[tag=officer_talk] run tp @s -1 81 -5 -90 0
execute as @e[type=armor_stand,tag=follow,nbt=!{CustomNameVisible:1b}] at @s run tp @s ~ ~ ~ facing entity @p
execute as @e[type=falling_block] at @s if block ~ ~-0.1 ~ lava run kill @s
execute as @a[scores={death=1..}] run function main:reset
spawnpoint @a 0 81 0
execute if score Global sheepE matches 1.. run scoreboard players set Global sheepE 0